package com.kingdee.eas.custom.dormitorysystem.application.handler;

import com.kingdee.bos.Context;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.eas.basedata.org.HROrgUnitInfo;
import com.kingdee.eas.custom.dormitorysystem.application.CheckInApplicationEntryInfo;
import com.kingdee.eas.custom.dormitorysystem.application.CheckInApplicationInfo;
import com.kingdee.eas.framework.CoreBaseInfo;
import com.kingdee.eas.hr.base.HRBillBaseInfo;
import com.kingdee.shr.base.syssetting.IMSFServiceFacade;
import com.kingdee.shr.base.syssetting.MSFServiceFacadeFactory;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.exception.ShrWebBizException;
import com.kingdee.util.DateTimeUtils;
import org.apache.log4j.Logger;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Description ס뵥Handler
 * @Date 2025/4/24 13:48
 * @Created by Heyuan
 */
public class CheckInApplicationEditHandler extends DormitoryApplicationEditHandler {
    private static Logger logger = Logger.getLogger(CheckInApplicationSelfEditHandler.class);
    private Context ctx = SHRContext.getInstance().getContext();


    @Override
    protected void beforeSubmit(
            HttpServletRequest request,
            HttpServletResponse response,
            CoreBaseInfo model
    ) throws SHRWebException {
        HRBillBaseInfo hrBillBaseInfo = (HRBillBaseInfo) model;
        String billIds = hrBillBaseInfo.getId().toString();
        Map result = null;
        Map<String, String> params = new HashMap<String, String>();
        params.put("billIds", billIds);
        try {
            //У鷿Ƿס
            IMSFServiceFacade imsfServiceFacade = MSFServiceFacadeFactory.getLocalInstance(ctx);
            result = (Map) imsfServiceFacade.processService("validateRoomAvailableByBillIdsService", params);
        } catch (Exception e) {
            logger.error(e);
            throw new ShrWebBizException("ýӿvalidateRoomAvailableByBillIdsService: " + e.getMessage());
        }
        Integer code = (Integer) result.get("code");
        if (500 == code) {
            List<String> errorMsgList = (List<String>) result.get("errorMsg");
            StringBuilder errorMsgBuilder = new StringBuilder();
            for (String errorMsg : errorMsgList) {
                errorMsgBuilder.append(errorMsg).append("\n");
            }
            throw new ShrWebBizException(errorMsgBuilder.toString());
        }
        //Уס뵥ǷظύУסϢʱ佻
        try {
            IMSFServiceFacade imsfServiceFacade = MSFServiceFacadeFactory.getLocalInstance(ctx);
            result = (Map) imsfServiceFacade.processService("checkDuplicateCheckInByBillIdService", params);
        } catch (Exception e) {
            logger.error(e);
            throw new ShrWebBizException("ýӿcheckDuplicateCheckInByBillIdService: " + e.getMessage());
        }
        if (500 == (Integer) result.get("code")) {
            List<String> errorMsgList = (List<String>) result.get("errorMsg");
            StringBuilder errorMsgBuilder = new StringBuilder();
            for (String errorMsg : errorMsgList) {
                errorMsgBuilder.append(errorMsg).append("\n");
            }
            throw new ShrWebBizException(errorMsgBuilder.toString());
        }
        //õ״̬Ϊδ
        model.setInt("billState", 1);
        super.beforeSubmit(request, response, model);
    }


    /**
     * ÷
     *
     * @param request
     * @param response
     * @param coreBaseInfo
     * @throws SHRWebException
     */
    protected void afterCreateNewModel(
            HttpServletRequest request,
            HttpServletResponse response,
            CoreBaseInfo coreBaseInfo
    ) throws SHRWebException {
        try {
            Context ctx = SHRContext.getInstance().getContext();
            CheckInApplicationInfo checkInApplicationInfo = (CheckInApplicationInfo) coreBaseInfo;
            HROrgUnitInfo hrOrgUnitInfo = new HROrgUnitInfo();
            hrOrgUnitInfo.setId(BOSUuid.read("00000000-0000-0000-0000-000000000000CCE7AED4"));
            checkInApplicationInfo.setHrOrgUnit(hrOrgUnitInfo);
            checkInApplicationInfo.setManagementNotes("Ը" +
                    "\n1Ծع˾ƶȡԱйع취˽Եʹλ" +
                    "\n2Ծάṫ𻵹Ծ⳥ 3ԾȫԼõˮ" +
                    "\n3ԾȫԼõˮ");
            //¼
            CheckInApplicationEntryInfo entryInfo = new CheckInApplicationEntryInfo();
            entryInfo.setCheckoutDate(DateTimeUtils.parseDate("2199-12-31", "yyyy-MM-dd"));
            checkInApplicationInfo.getEntrys().add(entryInfo);
        } catch (Exception e) {
            logger.error(e);
            throw new ShrWebBizException(e);
        }
    }
}
