package com.kingdee.eas.custom.dormitorysystem.application.service;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.BOSObjectFactory;
import com.kingdee.bos.Context;
import com.kingdee.bos.bsf.service.app.IHRMsfService;
import com.kingdee.bos.dao.AbstractObjectCollection;
import com.kingdee.bos.metadata.entity.*;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.eas.basedata.person.PersonInfo;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.dormitorysystem.application.*;
import com.kingdee.eas.custom.dormitorysystem.occupants.IOccupants;
import com.kingdee.eas.custom.dormitorysystem.occupants.OccupantsCollection;
import com.kingdee.eas.custom.dormitorysystem.occupants.OccupantsFactory;
import com.kingdee.eas.custom.dormitorysystem.occupants.OccupantsInfo;
import com.kingdee.eas.framework.CoreBillBaseCollection;
import com.kingdee.eas.framework.ICoreBillBase;
import com.kingdee.eas.hr.ats.AtsUtil;
import com.kingdee.eas.hr.base.HRBillBaseEntryInfo;
import com.kingdee.eas.hr.base.HRBillBaseInfo;
import com.kingdee.util.StringUtils;
import org.apache.log4j.Logger;

import java.text.SimpleDateFormat;
import java.util.*;

/**
 * @Description ס뵥ǷظסϢǷظ
 * @Date 2025/4/29 17:03
 * @Created by Heyuan
 */
public class CheckDuplicateCheckInByBillIdService implements IHRMsfService {
    private static Logger logger = Logger.getLogger(CheckDuplicateCheckInByBillIdService.class);

    @Override
    public Object process(
            Context ctx,
            Map<String, Object> params
    ) throws EASBizException, BOSException {
        String billIds = (String) params.get("billIds");
        if (StringUtils.isEmpty(billIds)) {
            logger.error("idΪ!");
            throw new BOSException("idΪ!");
        }
        Map<String, List<Map<String, Date>>> roomListMap = new HashMap<>();
        List<String> errorMsgList = new ArrayList<>();
        ICoreBillBase iCoreBillBase = (ICoreBillBase) BOSObjectFactory.createBOSObject(ctx,
                BOSUuid.read(billIds.split(",")[0]).getType());
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("*");
        sic.add("entrys.*");
        sic.add("entrys.person.*");
        sic.add("entrys.person.personType.*");
        sic.add("entrys.checkInRoom.*");
        sic.add("entrys.checkInRoom.DormitoryType.*");
        FilterInfo filterInfo = new FilterInfo();
        FilterItemCollection filterItems = filterInfo.getFilterItems();
        //
        filterItems.add(new FilterItemInfo("id", AtsUtil.toSet(billIds), CompareType.INCLUDE));
        EntityViewInfo viewInfo = EntityViewInfo.getInstance(filterInfo, sic, null);
        CoreBillBaseCollection hrBillBaseCollection = iCoreBillBase.getCoreBillBaseCollection(viewInfo);
        for (int i = 0; i < hrBillBaseCollection.size(); i++) {
            HRBillBaseInfo hrBillBaseInfo = (HRBillBaseInfo) hrBillBaseCollection.get(i);
            String baseInfoNumber = hrBillBaseInfo.getNumber();
            //¼
            AbstractObjectCollection entrys = (AbstractObjectCollection) hrBillBaseInfo.get("entrys");
            for (int j = 0; j < entrys.size(); j++) {
                try {
                    HRBillBaseEntryInfo entryInfo = (HRBillBaseEntryInfo) entrys.getObject(j);
                    //ס
                    Date checkInDate = entryInfo.getDate("checkInDate");
                    if (checkInDate == null) {
                        throw new BOSException("סڲΪ!");
                    }
                    //
                    Date checkoutDate = entryInfo.getDate("checkoutDate");
                    if (checkoutDate == null) {
                        throw new BOSException("ڲΪ!");
                    }
                    //Ա
                    PersonInfo personInfo = (PersonInfo) entryInfo.getObjectValue("person");
                    if (personInfo == null) {
                        throw new BOSException("ԱΪ!");
                    }
                    //1.Աסڡڼס뵥Ƿظ
                    checkDuplicateCheckIn(ctx, personInfo, checkInDate, checkoutDate, entryInfo);
                    //2.ԱסڡڼסԱϢǷظ
                    checkDuplicateOccupants(ctx, personInfo, checkInDate, checkoutDate);
                    //3.Աסڡڼ黻޵Ƿظ
                    checkDuplicateRoomChange(ctx, personInfo, checkInDate, checkoutDate);
                } catch (Exception e) {
                    logger.error("ݱΪ" + baseInfoNumber + "Уδͨ: " + e.getMessage());
                    errorMsgList.add("ݱΪ" + baseInfoNumber + "Уδͨ: " + e.getMessage());
                }
            }
        }
        Map result = new HashMap();
        if (errorMsgList.size() > 0) {
            result.put("code", 500);
            result.put("errorMsg", errorMsgList);
        } else {
            result.put("code", 200);
        }
        return result;
    }

    /**
     * Աסڡڼ黻޵Ƿظ
     *
     * @param ctx
     * @param personInfo
     * @param checkInDate
     * @param checkoutDate
     */
    protected void checkDuplicateRoomChange(
            Context ctx,
            PersonInfo personInfo,
            Date checkInDate,
            Date checkoutDate
    ) throws BOSException {
        String personInfoName = personInfo.getName();
        IRoomChangeApplicationEntry iRoomChangeApplicationEntry = RoomChangeApplicationEntryFactory.getLocalInstance(ctx);
        FilterInfo filterInfo = new FilterInfo();
        FilterItemCollection filterItems = filterInfo.getFilterItems();
        //Ա
        filterItems.add(new FilterItemInfo("person", personInfo.getId()));
        //ססں֮
        filterItems.add(new FilterItemInfo("checkInDate", checkInDate, CompareType.LESS_EQUALS));
        filterItems.add(new FilterItemInfo("checkoutDate", checkInDate, CompareType.GREATER_EQUALS));
        //ססں֮
        filterItems.add(new FilterItemInfo("checkInDate", checkInDate, CompareType.GREATER_EQUALS));
        filterItems.add(new FilterItemInfo("checkInDate", checkoutDate, CompareType.LESS_EQUALS));
        filterInfo.setMaskString("#0 and ((#1 and #2) or (#3 and #4))");
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("parent.number");
        EntityViewInfo viewInfo = EntityViewInfo.getInstance(filterInfo, sic, null);
        RoomChangeApplicationEntryCollection entryCollection = iRoomChangeApplicationEntry.getRoomChangeApplicationEntryCollection(viewInfo);
        StringBuilder errorMsg = new StringBuilder();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        for (int i = 0; i < entryCollection.size(); i++) {
            RoomChangeApplicationEntryInfo roomChangeApplicationEntryInfo = entryCollection.get(i);
            RoomChangeApplicationInfo parent = roomChangeApplicationEntryInfo.getParent();
            String number = parent.getNumber();
            errorMsg.append("Ա[" + personInfoName + "][" + sdf.format(checkInDate) + "] ~ [" + sdf.format(checkoutDate) + "]ڼ뻻뵥[" + number + "]ڴڽ\n");
        }
        if (errorMsg.length() > 0) {
            throw new BOSException(errorMsg.toString());
        }
    }


    /**
     * ԱסڡڼסԱϢǷظ
     *
     * @param ctx
     * @param personInfo   Ա
     * @param checkInDate  ס
     * @param checkoutDate 
     * @throws BOSException
     */
    protected void checkDuplicateOccupants(
            Context ctx,
            PersonInfo personInfo,
            Date checkInDate,
            Date checkoutDate
    ) throws BOSException {
        String personInfoName = personInfo.getName();
        IOccupants iOccupants = OccupantsFactory.getLocalInstance(ctx);
        FilterInfo filterInfo = new FilterInfo();
        FilterItemCollection filterItems = filterInfo.getFilterItems();
        //Ա
        filterItems.add(new FilterItemInfo("person", personInfo.getId()));
        //ססں֮
        filterItems.add(new FilterItemInfo("CheckInDate", checkInDate, CompareType.LESS_EQUALS));
        filterItems.add(new FilterItemInfo("CheckOutDate", checkInDate, CompareType.GREATER_EQUALS));
        //ססں֮
        filterItems.add(new FilterItemInfo("CheckInDate", checkInDate, CompareType.GREATER_EQUALS));
        filterItems.add(new FilterItemInfo("CheckInDate", checkoutDate, CompareType.LESS_EQUALS));
        filterInfo.setMaskString("#0 and ((#1 and #2) or (#3 and #4))");
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("parent.number");
        EntityViewInfo viewInfo = EntityViewInfo.getInstance(filterInfo, sic, null);
        OccupantsCollection occupantsCollection = iOccupants.getOccupantsCollection(viewInfo);
        StringBuilder errorMsg = new StringBuilder();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        if (occupantsCollection.size() > 0) {
            errorMsg.append("Ա[" + personInfoName + "][" + sdf.format(checkInDate) + "] ~ [" + sdf.format(checkoutDate) + "]ڼסϢݴڽ\n");
            throw new BOSException(errorMsg.toString());
        }
    }

    /**
     * Աסڡڼ鵥״̬Ϊύлͨס뵥Ƿظ
     *
     * @param ctx
     * @param personInfo   Ա
     * @param checkInDate  ס
     * @param checkoutDate 
     * @throws BOSException
     * @throws EASBizException
     */
    protected void checkDuplicateCheckIn(
            Context ctx,
            PersonInfo personInfo,
            Date checkInDate,
            Date checkoutDate,
            HRBillBaseEntryInfo entryInfo
    ) throws BOSException {
        String personInfoName = personInfo.getName();
        String entryId = entryInfo.getId().toString();
        ICheckInApplicationEntry iCheckInApplicationEntry = CheckInApplicationEntryFactory.getLocalInstance(ctx);
        FilterInfo filterInfo = new FilterInfo();
        FilterItemCollection filterItems = filterInfo.getFilterItems();
        //״̬ύлͨ
        filterItems.add(new FilterItemInfo("parent.billState", "1,2,3", CompareType.INCLUDE));
        //ססں֮
        filterItems.add(new FilterItemInfo("checkInDate", checkInDate, CompareType.LESS_EQUALS));
        filterItems.add(new FilterItemInfo("checkoutDate", checkInDate, CompareType.GREATER_EQUALS));
        //ססں֮
        filterItems.add(new FilterItemInfo("checkInDate", checkInDate, CompareType.GREATER_EQUALS));
        filterItems.add(new FilterItemInfo("checkInDate", checkoutDate, CompareType.LESS_EQUALS));
        //Ա
        filterItems.add(new FilterItemInfo("person", personInfo.getId()));
        //ڵǰ¼
        filterItems.add(new FilterItemInfo("id", entryId, CompareType.NOTEQUALS));
        filterInfo.setMaskString("#0 and ((#1 and #2) or (#3 and #4)) and #5 and #6");
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("parent.number");
        sic.add("occupants.id");
        EntityViewInfo viewInfo = EntityViewInfo.getInstance(filterInfo, sic, null);
        CheckInApplicationEntryCollection entryCollection = iCheckInApplicationEntry.getCheckInApplicationEntryCollection(viewInfo);
        StringBuilder errorMsg = new StringBuilder();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        IRoomChangeApplicationEntry iRoomChangeApplicationEntry = RoomChangeApplicationEntryFactory.getLocalInstance(ctx);
        ICheckoutApplicationEntry iCheckoutApplicationEntry = CheckoutApplicationEntryFactory.getLocalInstance(ctx);
        for (int i = 0; i < entryCollection.size(); i++) {
            CheckInApplicationEntryInfo checkInApplicationEntryInfo = entryCollection.get(i);
            //סϢ
            OccupantsInfo occupants = checkInApplicationEntryInfo.getOccupants();
            if (occupants != null) {
                String occupantsId = occupants.getId().toString();
                try {
                    //жϸס뵥ӦסϢǷͨ޵,ھס뵥
                    FilterInfo existsFilter = new FilterInfo();
                    FilterItemCollection existsFilterItems = existsFilter.getFilterItems();
                    existsFilterItems.add(new FilterItemInfo("parent.billState", "3"));
                    existsFilterItems.add(new FilterItemInfo("occupants", occupantsId));
                    if (iCheckoutApplicationEntry.exists(existsFilter)) {
                        continue;
                    }
                } catch (EASBizException e) {
                    logger.error("У޵:" + e.getMessage(), e);
                    throw new BOSException(e);
                }
                try {
                    //жϸס뵥ӦסϢǷͨ޵,ھס뵥
                    FilterInfo existsFilter = new FilterInfo();
                    FilterItemCollection existsFilterItems = existsFilter.getFilterItems();
                    existsFilterItems.add(new FilterItemInfo("parent.billState", "3"));
                    existsFilterItems.add(new FilterItemInfo("oldOccupants", occupantsId));
                    if (iRoomChangeApplicationEntry.exists(existsFilter)) {
                        continue;
                    }
                } catch (EASBizException e) {
                    logger.error("У黻޵:" + e.getMessage(), e);
                    throw new BOSException(e);
                }
            }
            CheckInApplicationInfo parent = checkInApplicationEntryInfo.getParent();
            String number = parent.getNumber();
            errorMsg.append("Ա[" + personInfoName + "][" + sdf.format(checkInDate) + "] ~ [" + sdf.format(checkoutDate) + "]ڼס뵥[" + number + "]ڴڽ\n");
        }
        if (errorMsg.length() > 0) {
            throw new BOSException(errorMsg.toString());
        }
    }
}