package com.kingdee.eas.custom.dormitorysystem.application.service;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.BOSObjectFactory;
import com.kingdee.bos.Context;
import com.kingdee.bos.bsf.service.app.IHRMsfService;
import com.kingdee.bos.dao.AbstractObjectCollection;
import com.kingdee.bos.metadata.entity.*;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.eas.basedata.person.Genders;
import com.kingdee.eas.basedata.person.PersonInfo;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.dormitorysystem.application.*;
import com.kingdee.eas.custom.dormitorysystem.dormitory.DormitoryFactory;
import com.kingdee.eas.custom.dormitorysystem.dormitory.DormitoryInfo;
import com.kingdee.eas.custom.dormitorysystem.dormitory.IDormitory;
import com.kingdee.eas.custom.dormitorysystem.enumerationset.DormitoryClassification;
import com.kingdee.eas.custom.dormitorysystem.occupants.IOccupants;
import com.kingdee.eas.custom.dormitorysystem.occupants.OccupantsCollection;
import com.kingdee.eas.custom.dormitorysystem.occupants.OccupantsFactory;
import com.kingdee.eas.custom.dormitorysystem.occupants.OccupantsInfo;
import com.kingdee.eas.custom.dormitorysystem.otherbasicdata.DormitoryTypeInfo;
import com.kingdee.eas.custom.dormitorysystem.otherbasicdata.PersonDormitoryTypeInfo;
import com.kingdee.eas.framework.*;
import com.kingdee.eas.hr.ats.AtsUtil;
import com.kingdee.eas.hr.base.*;
import com.kingdee.shr.base.syssetting.BasicItemStateEnum;
import com.kingdee.util.StringUtils;
import org.apache.log4j.Logger;

import java.util.*;

/**
 * @Description ݵidУ鷿Ƿס()
 * @Date 2025/4/27 17:00
 * @Created by Heyuan
 */
public class ValidateRoomAvailableByBillIdsService implements IHRMsfService {
    private static Logger logger = Logger.getLogger(ValidateRoomAvailableByBillIdsService.class);
//    private static Map<String, ICoreBase> bizInterface = new HashMap();
//    static {
//        bizInterface.put("",)
//    }

    @Override
    public Object process(
            Context ctx,
            Map<String, Object> params
    ) throws EASBizException, BOSException {
        String billIds = (String) params.get("billIds");
        if (StringUtils.isEmpty(billIds)) {
            logger.error("idΪ!");
            throw new BOSException("idΪ!");
        }
        //BatchMessageTipsHeader batchMessageTipsHeader = new BatchMessageTipsHeader();
        // addBatchMessageTips(ids, "̸֪ͨʧ", batchMessageTipsHeader);
        Map<String, List<Map<String, Date>>> roomListMap = new HashMap<String, List<Map<String, Date>>>();
        //StringBuilder errorMsg = new StringBuilder();
        List<String> errorMsgList = new ArrayList<String>();
        // HRBillBaseFactory.getLocalInstance()
        ICoreBillBase iCoreBillBase = (ICoreBillBase) BOSObjectFactory.createBOSObject(ctx,
                BOSUuid.read(billIds.split(",")[0]).getType());
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("*");
        sic.add("entrys.*");
        sic.add("entrys.person.*");
        sic.add("entrys.person.personType.*");
        sic.add("entrys.checkInRoom.*");
        sic.add("entrys.checkInRoom.DormitoryType.*");
        FilterInfo filterInfo = new FilterInfo();
        FilterItemCollection filterItems = filterInfo.getFilterItems();
        //
        filterItems.add(new FilterItemInfo("id", AtsUtil.toSet(billIds), CompareType.INCLUDE));
        EntityViewInfo viewInfo = EntityViewInfo.getInstance(filterInfo, sic, null);
        CoreBillBaseCollection hrBillBaseCollection = iCoreBillBase.getCoreBillBaseCollection(viewInfo);
        for (int i = 0; i < hrBillBaseCollection.size(); i++) {
            HRBillBaseInfo hrBillBaseInfo = (HRBillBaseInfo) hrBillBaseCollection.get(i);
            //String billId = hrBillBaseInfo.getId().toString();
            String baseInfoNumber = hrBillBaseInfo.getNumber();
            String bosType = hrBillBaseInfo.getId().getType().toString();
            AbstractObjectCollection entrys = (AbstractObjectCollection) hrBillBaseInfo.get("entrys");
            for (int j = 0; j < entrys.size(); j++) {
                try {
                    HRBillBaseEntryInfo entryInfo = (HRBillBaseEntryInfo) entrys.getObject(j);
                    Date checkInDate = null;
                    if ("B371AC0A".equals(bosType)) {
                        //޵
                        //ס
                        checkInDate = entryInfo.getDate("adjustmentDate");
                    } else {
                        //ס
                        checkInDate = entryInfo.getDate("checkInDate");
                    }
                    if (checkInDate == null) {
                        throw new BOSException("סڲΪ!");
                    }
                    //
                    Date checkoutDate = entryInfo.getDate("checkoutDate");
                    if (checkoutDate == null) {
                        throw new BOSException("ڲΪ!");
                    }
                    //Ա
                    PersonInfo personInfo = (PersonInfo) entryInfo.getObjectValue("person");
                    if (personInfo == null) {
                        throw new BOSException("ԱΪ!");
                    }
                    //
                    DormitoryInfo dormitory = (DormitoryInfo) entryInfo.getObjectValue("checkInRoom");
                    if (dormitory == null) {
                        throw new BOSException("䲻Ϊ!");
                    }
                    String roomId = dormitory.getId().toString();
                    //ס,Ա,Աѯѡ
                    //Ա
                    PersonDormitoryTypeInfo personType = (PersonDormitoryTypeInfo) personInfo.get("personType");
                    if (personType == null) {
                        throw new BOSException("Ա[" + personInfo.getName() + "]ԱΪգ뼰ʱά");
                    }
                    //String personTypeId = personType.getId().toString();
                    //ס
                    int dormCheckInCount = 0;
                    //ۼӵԱסϢidظۼ
                    Set<String> occupantsIds = new HashSet<String>();
                    //1.У鷿Ϣ
                    validateDormitoryInfo(ctx, personInfo, dormitory);
                    //ס
                    int occupancyCapacity = dormitory.getOccupancyCapacity();
                    //2.סںסϢס
                    dormCheckInCount += getCheckInInfoByOccupants(ctx, checkInDate, checkoutDate, roomId, personType, occupantsIds);
                    System.out.println("dormCheckInCount1 :" + dormCheckInCount);
                    //3.סںס뵥״̬Ϊеס
                    dormCheckInCount += getCheckInInfoByCheckInApplication(ctx, checkInDate, checkoutDate, roomId, personType, occupantsIds);
                    System.out.println("dormCheckInCount2 :" + dormCheckInCount);
                    //4.סں뵥״̬Ϊеס
                    dormCheckInCount += getRoomChangeInfoByRoomChangeApplication(ctx, checkInDate, checkoutDate, roomId, personType, occupantsIds);
                    System.out.println("dormCheckInCount3 :" + dormCheckInCount);
                    //5.ݵǰס
                    if (roomListMap.containsKey(roomId)) {
                        List<Map<String, Date>> roomMapList = roomListMap.get(roomId);
                        for (int k = 0; k < roomMapList.size(); k++) {
                            Map<String, Date> roomMap = roomMapList.get(k);
                            Date checkInDateOld = roomMap.get("checkInDate");
                            Date checkoutDateOld = roomMap.get("checkoutDate");
                            //ססں֮
                            //ססں֮
                            if ((checkInDateOld.compareTo(checkInDate) <= 0 && checkoutDateOld.compareTo(checkInDate) >= 0)
                                    || (checkInDateOld.compareTo(checkInDate) >= 0 && checkInDateOld.compareTo(checkoutDate) <= 0)) {
                                dormCheckInCount++;
                            }
                        }
                    }
                    System.out.println("dormCheckInCount4 :" + dormCheckInCount);
                    //ۼӵǰԱ
                    dormCheckInCount++;
                    //6.ʣס: ס - ס
                    if (occupancyCapacity - dormCheckInCount < 0) {
                        String dormitoryName = dormitory.getName();
                        throw new BOSException("ǰס" + dormCheckInCount + "ѳ[" + dormitoryName + "]ס" + occupancyCapacity + "ס!");
                    }
                    Map roomMap = new HashMap();
                    roomMap.put("checkInDate", checkInDate);
                    roomMap.put("checkoutDate", checkoutDate);
                    if (roomListMap.containsKey(roomId)) {
                        roomListMap.get(roomId).add(roomMap);
                    } else {
                        List list = new ArrayList();
                        roomListMap.put(roomId, list);
                        list.add(roomMap);
                    }
                } catch (Exception e) {
                    logger.error("ݱΪ" + baseInfoNumber + "Уδͨ: " + e.getMessage(), e);
                    errorMsgList.add("ݱΪ" + baseInfoNumber + "Уδͨ: " + e.getMessage());
                    //errorMsg.append("ݱΪ").append(baseInfoNumber).append("Уδͨ: ").append(e.getMessage()).append(System.lineSeparator());
                }
            }
        }
        Map result = new HashMap();
        if (errorMsgList.size() > 0) {
            result.put("code", 500);
            result.put("errorMsg", errorMsgList);
        } else {
            result.put("code", 200);
        }
        return result;
    }

    /**
     * סں뵥״̬Ϊеס
     *
     * @param ctx
     * @param checkInDate  ס
     * @param checkoutDate 
     * @param roomId       id
     * @param personType   Ա
     * @return
     * @throws BOSException
     */
    private int getRoomChangeInfoByRoomChangeApplication(
            Context ctx,
            Date checkInDate,
            Date checkoutDate,
            String roomId,
            PersonDormitoryTypeInfo personType,
            Set<String> occupantsIds
    ) throws BOSException {
        IRoomChangeApplicationEntry iRoomChangeApplicationEntry = RoomChangeApplicationEntryFactory.getLocalInstance(ctx);
        FilterInfo filterInfo = new FilterInfo();
        FilterItemCollection filterItems = filterInfo.getFilterItems();
        //
        filterItems.add(new FilterItemInfo("adjustRoom", roomId));
        //ססں֮
        filterItems.add(new FilterItemInfo("checkInDate", checkInDate, CompareType.LESS_EQUALS));
        filterItems.add(new FilterItemInfo("checkoutDate", checkInDate, CompareType.GREATER_EQUALS));
        //ססں֮
        filterItems.add(new FilterItemInfo("checkInDate", checkInDate, CompareType.GREATER_EQUALS));
        filterItems.add(new FilterItemInfo("checkInDate", checkoutDate, CompareType.LESS_EQUALS));
        //״̬
        filterItems.add(new FilterItemInfo("parent.billState", "1,2", CompareType.INCLUDE));
        filterInfo.setMaskString("#0 and ((#1 and #2) or (#3 and #4)) and #5");
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("checkInRoom.id");
        sic.add("person.personType.id");
        sic.add("person.personType.name");
        sic.add("occupants.id");
        EntityViewInfo viewInfo = EntityViewInfo.getInstance(filterInfo, sic, null);
        RoomChangeApplicationEntryCollection roomChangeApplicationEntryCol = iRoomChangeApplicationEntry.getRoomChangeApplicationEntryCollection(viewInfo);
        String personTypeId = personType.getId().toString();
        String personTypeName = personType.getName();
        //ס
        int dormCheckInCount = 0;
        for (int i = 0; i < roomChangeApplicationEntryCol.size(); i++) {
            RoomChangeApplicationEntryInfo roomChangeApplicationEntryInfo = roomChangeApplicationEntryCol.get(i);
            //
            PersonInfo person = roomChangeApplicationEntryInfo.getPerson();
            String personName = person.getName();
            //Ա
            PersonDormitoryTypeInfo personDormitoryType = (PersonDormitoryTypeInfo) person.get("personType");
            if (personDormitoryType == null) {
                throw new BOSException("Ա[" + personName + "]ԱΪգ뼰ʱά");
            }
            String personDormitoryTypeId = personDormitoryType.getId().toString();
            String personDormitoryTypeName = personDormitoryType.getName();
            if (!personTypeId.equals(personDormitoryTypeId)) {
                throw new BOSException("Ա[" + personTypeName + "][" + personDormitoryTypeName + "]ס");
            }
            //סԱϢ
//            OccupantsInfo occupants = roomChangeApplicationEntryInfo.getOccupants();
//            if (occupants != null) {
//                String occupantsId = occupants.getId().toString();
//                if (occupantsIds.contains(occupantsId)) {
//                    continue;
//                }
//            }
            //ۼס
            dormCheckInCount++;
        }
        return dormCheckInCount;
    }

    /**
     * סںס뵥״̬Ϊеס
     *
     * @param ctx
     * @param checkInDate  ס
     * @param checkoutDate 
     * @param roomId       id
     * @param personType   Ա
     * @return
     * @throws BOSException
     */
    private int getCheckInInfoByCheckInApplication(
            Context ctx,
            Date checkInDate,
            Date checkoutDate,
            String roomId,
            PersonDormitoryTypeInfo personType,
            Set<String> occupantsIds
    ) throws BOSException {
        ICheckInApplicationEntry iCheckInApplicationEntry = CheckInApplicationEntryFactory.getLocalInstance(ctx);
        FilterInfo filterInfo = new FilterInfo();
        FilterItemCollection filterItems = filterInfo.getFilterItems();
        //
        filterItems.add(new FilterItemInfo("checkInRoom", roomId));
        //ססں֮
        filterItems.add(new FilterItemInfo("checkInDate", checkInDate, CompareType.LESS_EQUALS));
        filterItems.add(new FilterItemInfo("checkoutDate", checkInDate, CompareType.GREATER_EQUALS));
        //ססں֮
        filterItems.add(new FilterItemInfo("checkInDate", checkInDate, CompareType.GREATER_EQUALS));
        filterItems.add(new FilterItemInfo("checkInDate", checkoutDate, CompareType.LESS_EQUALS));
        //״̬
        filterItems.add(new FilterItemInfo("parent.billState", "1,2", CompareType.INCLUDE));
        filterInfo.setMaskString("#0 and ((#1 and #2) or (#3 and #4)) and #5");
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("checkInRoom.id");
        sic.add("person.personType.id");
        sic.add("person.personType.name");
        //sic.add("occupants.id");
        EntityViewInfo viewInfo = EntityViewInfo.getInstance(filterInfo, sic, null);
        CheckInApplicationEntryCollection checkInApplicationEntryCol = iCheckInApplicationEntry.getCheckInApplicationEntryCollection(viewInfo);
        String personTypeId = personType.getId().toString();
        String personTypeName = personType.getName();
        //ס
        int dormCheckInCount = 0;
        for (int i = 0; i < checkInApplicationEntryCol.size(); i++) {
            CheckInApplicationEntryInfo checkInApplicationEntryInfo = checkInApplicationEntryCol.get(i);
            //
            PersonInfo person = checkInApplicationEntryInfo.getPerson();
            String personName = person.getName();
            //Ա
            PersonDormitoryTypeInfo personDormitoryType = (PersonDormitoryTypeInfo) person.get("personType");
            if (personDormitoryType == null) {
                throw new BOSException("Ա[" + personName + "]ԱΪգ뼰ʱά");
            }
            String personDormitoryTypeId = personDormitoryType.getId().toString();
            String personDormitoryTypeName = personDormitoryType.getName();
            if (!personTypeId.equals(personDormitoryTypeId)) {
                throw new BOSException("Ա[" + personTypeName + "][" + personDormitoryTypeName + "]ס");
            }
            //סԱϢ
//            OccupantsInfo occupants = checkInApplicationEntryInfo.getOccupants();
//            if (occupants != null) {
//                String occupantsId = occupants.getId().toString();
//                if (occupantsIds.contains(occupantsId)) {
//                    continue;
//                }
//            }
            //ۼס
            dormCheckInCount++;
        }
        return dormCheckInCount;
    }


    /**
     * סںסϢÿס
     *
     * @param ctx
     * @param checkInDate  ס
     * @param checkoutDate 
     * @param roomId       id
     * @param personType   Ա
     * @return
     * @throws BOSException
     */
    protected int getCheckInInfoByOccupants(
            Context ctx,
            Date checkInDate,
            Date checkoutDate,
            String roomId,
            PersonDormitoryTypeInfo personType,
            Set<String> occupantsIds
    ) throws BOSException {
        IOccupants iOccupants = OccupantsFactory.getLocalInstance(ctx);
        FilterInfo filterInfo = new FilterInfo();
        FilterItemCollection filterItems = filterInfo.getFilterItems();
        //
        filterItems.add(new FilterItemInfo("Dormitory", roomId));
        //ססں֮
        filterItems.add(new FilterItemInfo("checkInDate", checkInDate, CompareType.LESS_EQUALS));
        filterItems.add(new FilterItemInfo("checkoutDate", checkInDate, CompareType.GREATER_EQUALS));
        //ססں֮
        filterItems.add(new FilterItemInfo("checkInDate", checkInDate, CompareType.GREATER_EQUALS));
        filterItems.add(new FilterItemInfo("checkInDate", checkoutDate, CompareType.LESS_EQUALS));
        filterInfo.setMaskString("#0 and ((#1 and #2) or (#3 and #4)) ");
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("PersonDormitoryType.id");
        sic.add("PersonDormitoryType.name");
        sic.add("id");
        EntityViewInfo viewInfo = EntityViewInfo.getInstance(filterInfo, sic, null);
        OccupantsCollection occupantsCollection = iOccupants.getOccupantsCollection(viewInfo);
        String personTypeId = personType.getId().toString();
        String personTypeName = personType.getName();
        //ס
        int dormCheckInCount = 0;
        String personDormitoryTypeId = null;
        for (int i = 0; i < occupantsCollection.size(); i++) {
            OccupantsInfo occupantsInfo = occupantsCollection.get(i);
            //Ա
            PersonDormitoryTypeInfo personDormitoryType = occupantsInfo.getPersonDormitoryType();
            personDormitoryTypeId = personDormitoryType.getId().toString();
            String personDormitoryTypeName = personDormitoryType.getName();
            if (!personTypeId.equals(personDormitoryTypeId)) {
                throw new BOSException("Ա[" + personTypeName + "][" + personDormitoryTypeName + "]ס");
            }
            occupantsIds.add(occupantsInfo.getId().toString());
            dormCheckInCount++;
        }
        return dormCheckInCount;
    }

    /**
     * У鷿Ϣ
     *
     * @param ctx
     * @param personInfo
     * @param dormitory  
     * @return
     * @throws BOSException
     * @throws EASBizException
     */
    protected void validateDormitoryInfo(
            Context ctx,
            PersonInfo personInfo,
            DormitoryInfo dormitory
    ) throws BOSException, EASBizException {
        Genders gender = personInfo.getGender();
        if (gender == null) {
            throw new BOSException("ԱԱΪ!");
        }
        String personInfoName = personInfo.getName();
        IDormitory iDormitory = DormitoryFactory.getLocalInstance(ctx);
        //ѯϢ
        String dormitoryName = dormitory.getName();
        DormitoryClassification roomClassification = dormitory.getRoomClassification();
        if (!DormitoryClassification.ROOM.equals(roomClassification)) {
            String classificationAlias = roomClassification.getAlias();
            throw new BOSException("[" + dormitoryName + "]Ϊ" + classificationAlias + "ס!");
        }
        BasicItemStateEnum dormitoryInfoState = dormitory.getState();
        if (BasicItemStateEnum.DISABLE.equals(dormitoryInfoState)) {
            throw new BOSException("[" + dormitoryName + "]δãס!");
        }
        //
        DormitoryTypeInfo dormitoryType = dormitory.getDormitoryType();
        Genders roomGender = dormitoryType.getGender();
        if (roomGender != null && gender.getValue() != roomGender.getValue()) {
            String dormitoryTypeName = dormitoryType.getName();
            throw new BOSException("[" + dormitoryName + "]Ϊ" + dormitoryTypeName + "Ա[" + personInfoName + "]Ա𲻷!");
        }
    }
}
