package com.kingdee.eas.custom.dormitorysystem.application.service;

import com.kingdee.eas.custom.dormitorysystem.application.*;
import com.kingdee.eas.custom.dormitorysystem.enumerationset.DormitoryClassification;
import com.kingdee.eas.custom.dormitorysystem.otherbasicdata.DormitoryTypeInfo;
import com.kingdee.shr.base.syssetting.BasicItemStateEnum;
import org.apache.log4j.Logger;
import org.json.JSONArray;
import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.bsf.service.app.IHRMsfService;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.metadata.entity.*;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.eas.basedata.person.Genders;
import com.kingdee.eas.basedata.person.IPerson;
import com.kingdee.eas.basedata.person.PersonFactory;
import com.kingdee.eas.basedata.person.PersonInfo;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.dormitorysystem.dormitory.DormitoryFactory;
import com.kingdee.eas.custom.dormitorysystem.dormitory.DormitoryInfo;
import com.kingdee.eas.custom.dormitorysystem.dormitory.IDormitory;
import com.kingdee.eas.custom.dormitorysystem.occupants.IOccupants;
import com.kingdee.eas.custom.dormitorysystem.occupants.OccupantsCollection;
import com.kingdee.eas.custom.dormitorysystem.occupants.OccupantsFactory;
import com.kingdee.eas.custom.dormitorysystem.occupants.OccupantsInfo;
import com.kingdee.eas.custom.dormitorysystem.otherbasicdata.PersonDormitoryTypeInfo;
import com.kingdee.util.DateTimeUtils;
import com.kingdee.util.StringUtils;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.*;

/**
 * @Description У鷿Ƿס()
 * @Date 2025/4/27 17:00
 * @Created by Heyuan
 */
public class ValidateRoomAvailableService implements IHRMsfService {
    private static Logger logger = Logger.getLogger(ValidateRoomAvailableService.class);

    @Override
    public Object process(
            Context ctx,
            Map<String, Object> params
    ) throws EASBizException, BOSException {
        String validateDataStr = (String) params.get("validateData");
        if (StringUtils.isEmpty(validateDataStr)) {
            logger.error("УݲΪ!");
            throw new BOSException("УݲΪ!");
        }
        JSONArray validateDatas = null;
        try {
            validateDatas = new JSONArray(validateDataStr);
        } catch (JSONException e) {
            logger.error(e);
            throw new RuntimeException(e);
        }
        Map<String, List<Map<String, Date>>> roomListMap = new HashMap<String, List<Map<String, Date>>>();
        StringBuilder errorMsg = new StringBuilder();
        for (int i = 0; i < validateDatas.length(); i++) {
            try {
                JSONObject jsonObject = validateDatas.getJSONObject(i);
                //ס
                String checkInDateStr = jsonObject.getString("checkInDate");
                if (StringUtils.isEmpty(checkInDateStr)) {
                    throw new BOSException("סڲΪ!");
                }
                //
                String checkoutDateStr = jsonObject.getString("checkoutDate");
                if (StringUtils.isEmpty(checkInDateStr)) {
                    throw new BOSException("ڲΪ!");
                }
                //Աid
                String personId = jsonObject.getString("personId");
                if (StringUtils.isEmpty(personId)) {
                    throw new BOSException("ԱidΪ!");
                }
                //id
                String roomId = jsonObject.getString("roomId");
                if (StringUtils.isEmpty(personId)) {
                    throw new BOSException("idΪ!");
                }
                //ס
                Date checkInDate = DateTimeUtils.parseDate(checkInDateStr, "yyyy-MM-dd");
                Date checkoutDate = DateTimeUtils.parseDate(checkoutDateStr, "yyyy-MM-dd");
                //ס,Ա,Աѯѡ
                IPerson iPerson = PersonFactory.getLocalInstance(ctx);
                SelectorItemCollection sic = new SelectorItemCollection();
                sic.add("gender");
                sic.add("personType.*");
                sic.add("name");
                PersonInfo personInfo = iPerson.getPersonInfo(new ObjectUuidPK(personId), sic);
                //Ա
                PersonDormitoryTypeInfo personType = (PersonDormitoryTypeInfo) personInfo.get("personType");
                if (personType == null) {
                    throw new BOSException("Ա[" + personInfo.getName() + "]ԱΪգ뼰ʱά");
                }
                //String personTypeId = personType.getId().toString();
                //ס
                int dormCheckInCount = 0;
                //ۼӵԱסϢidظۼ
                Set<String> occupantsIds = new HashSet<String>();
                //1.У鷿Ϣ
                DormitoryInfo dormitoryInfo = validateDormitoryInfo(ctx, personInfo, roomId);
                //ס
                int occupancyCapacity = dormitoryInfo.getOccupancyCapacity();
                //2.סںסϢס
                dormCheckInCount += getCheckInInfoByOccupants(ctx, checkInDate, checkoutDate, roomId, personType, occupantsIds);
                //3.סںס뵥״̬Ϊеס
                dormCheckInCount += getCheckInInfoByCheckInApplication(ctx, checkInDate, checkoutDate, roomId, personType, occupantsIds);
                //4.סں뵥״̬Ϊеס
                dormCheckInCount += getRoomChangeInfoByRoomChangeApplication(ctx, checkInDate, checkoutDate, roomId, personType, occupantsIds);
                //5.ݵǰס
                if (roomListMap.containsKey(roomId)) {
                    List<Map<String, Date>> roomMapList = roomListMap.get(roomId);
                    for (int j = 0; j < roomMapList.size(); j++) {
                        Map<String, Date> roomMap = roomMapList.get(j);
                        Date checkInDateOld = roomMap.get("checkInDate");
                        Date checkoutDateOld = roomMap.get("checkoutDate");
                        //ססں֮
                        //ססں֮
                        if ((checkInDateOld.compareTo(checkInDate) <= 0 && checkoutDateOld.compareTo(checkInDate) >= 0)
                                || (checkInDateOld.compareTo(checkInDate) >= 0 && checkInDateOld.compareTo(checkoutDate) <= 0)) {
                            dormCheckInCount++;
                        }
                    }
                }
                //ۼӵǰԱ
                dormCheckInCount++;
                //6.ʣס: ס - ס
                if (occupancyCapacity - dormCheckInCount < 0) {
                    String dormitoryName = dormitoryInfo.getName();
                    throw new BOSException("ǰס" + dormCheckInCount + "ѳ[" + dormitoryName + "]ס" + occupancyCapacity + "ס!");
                }
                Map roomMap = new HashMap();
                roomMap.put("checkInDate", checkInDate);
                roomMap.put("checkoutDate", checkoutDate);
                if (roomListMap.containsKey(roomId)) {
                    roomListMap.get(roomId).add(roomMap);
                } else {
                    List list = new ArrayList();
                    roomListMap.put(roomId, list);
                    list.add(roomMap);
                }
            } catch (Exception e) {
                logger.error(e);
                errorMsg.append(e.getMessage()).append(System.lineSeparator());
            }
        }
        Map result = new HashMap();
        if (errorMsg.length() > 0) {
            result.put("code", 500);
            result.put("errorMsg", errorMsg.toString());
        } else {
            result.put("code", 200);
        }
        return result;
    }


    /**
     * סں뵥״̬Ϊеס
     *
     * @param ctx
     * @param checkInDate  ס
     * @param checkoutDate 
     * @param roomId       id
     * @param personType   Ա
     * @return
     * @throws BOSException
     */
    private int getRoomChangeInfoByRoomChangeApplication(
            Context ctx,
            Date checkInDate,
            Date checkoutDate,
            String roomId,
            PersonDormitoryTypeInfo personType,
            Set<String> occupantsIds
    ) throws BOSException {
        IRoomChangeApplicationEntry iRoomChangeApplicationEntry = RoomChangeApplicationEntryFactory.getLocalInstance(ctx);
        FilterInfo filterInfo = new FilterInfo();
        FilterItemCollection filterItems = filterInfo.getFilterItems();
        //
        filterItems.add(new FilterItemInfo("adjustRoom", roomId));
        //ססں֮
        filterItems.add(new FilterItemInfo("checkInDate", checkInDate, CompareType.LESS_EQUALS));
        filterItems.add(new FilterItemInfo("checkoutDate", checkInDate, CompareType.GREATER_EQUALS));
        //ססں֮
        filterItems.add(new FilterItemInfo("checkInDate", checkInDate, CompareType.GREATER_EQUALS));
        filterItems.add(new FilterItemInfo("checkInDate", checkoutDate, CompareType.LESS_EQUALS));
        //״̬
        filterItems.add(new FilterItemInfo("parent.billState", "1,2", CompareType.INCLUDE));
        filterInfo.setMaskString("#0 and ((#1 and #2) or (#3 and #4)) and #5");
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("checkInRoom.id");
        sic.add("person.personType.id");
        sic.add("person.personType.name");
//        sic.add("occupants.id");
//        sic.add("oldOccupants.id");
        EntityViewInfo viewInfo = EntityViewInfo.getInstance(filterInfo, sic, null);
        RoomChangeApplicationEntryCollection roomChangeApplicationEntryCol = iRoomChangeApplicationEntry.getRoomChangeApplicationEntryCollection(viewInfo);
        String personTypeId = personType.getId().toString();
        String personTypeName = personType.getName();
        //ס
        int dormCheckInCount = 0;
        for (int i = 0; i < roomChangeApplicationEntryCol.size(); i++) {
            RoomChangeApplicationEntryInfo roomChangeApplicationEntryInfo = roomChangeApplicationEntryCol.get(i);
            //
            PersonInfo person = roomChangeApplicationEntryInfo.getPerson();
            String personName = person.getName();
            //Ա
            PersonDormitoryTypeInfo personDormitoryType = (PersonDormitoryTypeInfo) person.get("personType");
            if (personDormitoryType == null) {
                throw new BOSException("Ա[" + personName + "]ԱΪգ뼰ʱά");
            }
            String personDormitoryTypeId = personDormitoryType.getId().toString();
            String personDormitoryTypeName = personDormitoryType.getName();
            if (!personTypeId.equals(personDormitoryTypeId)) {
                throw new BOSException("Ա[" + personTypeName + "][" + personDormitoryTypeName + "]ס");
            }
            //ԭסϢ
//            OccupantsInfo oldOccupants = roomChangeApplicationEntryInfo.getOldOccupants();
//            if (oldOccupants != null) {
//                String oldOccupantsId = oldOccupants.getId().toString();
//                if (occupantsIds.contains(oldOccupantsId)) {
//                    continue;
//                }
//            }
            //ۼס
            dormCheckInCount++;
        }
        return dormCheckInCount;
    }

    /**
     * סںס뵥״̬Ϊеס
     *
     * @param ctx
     * @param checkInDate  ס
     * @param checkoutDate 
     * @param roomId       id
     * @param personType   Ա
     * @return
     * @throws BOSException
     */
    private int getCheckInInfoByCheckInApplication(
            Context ctx,
            Date checkInDate,
            Date checkoutDate,
            String roomId,
            PersonDormitoryTypeInfo personType,
            Set<String> occupantsIds
    ) throws BOSException {
        ICheckInApplicationEntry iCheckInApplicationEntry = CheckInApplicationEntryFactory.getLocalInstance(ctx);
        FilterInfo filterInfo = new FilterInfo();
        FilterItemCollection filterItems = filterInfo.getFilterItems();
        //
        filterItems.add(new FilterItemInfo("checkInRoom", roomId));
        //ססں֮
        filterItems.add(new FilterItemInfo("checkInDate", checkInDate, CompareType.LESS_EQUALS));
        filterItems.add(new FilterItemInfo("checkoutDate", checkInDate, CompareType.GREATER_EQUALS));
        //ססں֮
        filterItems.add(new FilterItemInfo("checkInDate", checkInDate, CompareType.GREATER_EQUALS));
        filterItems.add(new FilterItemInfo("checkInDate", checkoutDate, CompareType.LESS_EQUALS));
        //״̬
        filterItems.add(new FilterItemInfo("parent.billState", "1,2", CompareType.INCLUDE));
        filterInfo.setMaskString("#0 and ((#1 and #2) or (#3 and #4)) and #5");
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("checkInRoom.id");
        sic.add("person.personType.id");
        sic.add("person.personType.name");
//        sic.add("occupants.id");
        EntityViewInfo viewInfo = EntityViewInfo.getInstance(filterInfo, sic, null);
        CheckInApplicationEntryCollection checkInApplicationEntryCol = iCheckInApplicationEntry.getCheckInApplicationEntryCollection(viewInfo);
        String personTypeId = personType.getId().toString();
        String personTypeName = personType.getName();
        //ס
        int dormCheckInCount = 0;
        for (int i = 0; i < checkInApplicationEntryCol.size(); i++) {
            CheckInApplicationEntryInfo checkInApplicationEntryInfo = checkInApplicationEntryCol.get(i);
            //
            PersonInfo person = checkInApplicationEntryInfo.getPerson();
            String personName = person.getName();
            //Ա
            PersonDormitoryTypeInfo personDormitoryType = (PersonDormitoryTypeInfo) person.get("personType");
            if (personDormitoryType == null) {
                throw new BOSException("Ա[" + personName + "]ԱΪգ뼰ʱά");
            }
            String personDormitoryTypeId = personDormitoryType.getId().toString();
            String personDormitoryTypeName = personDormitoryType.getName();
            if (!personTypeId.equals(personDormitoryTypeId)) {
                throw new BOSException("Ա[" + personTypeName + "][" + personDormitoryTypeName + "]ס");
            }
            //סԱϢ
//            OccupantsInfo occupants = checkInApplicationEntryInfo.getOccupants();
//            if (occupants != null) {
//                String occupantsId = occupants.getId().toString();
//                if (occupantsIds.contains(occupantsId)) {
//                    continue;
//                }
//            }
            //ۼס
            dormCheckInCount++;
        }
        return dormCheckInCount;
    }


    /**
     * סںסϢÿס
     *
     * @param ctx
     * @param checkInDate  ס
     * @param checkoutDate 
     * @param roomId       id
     * @param personType   Ա
     * @return
     * @throws BOSException
     */
    protected int getCheckInInfoByOccupants(
            Context ctx,
            Date checkInDate,
            Date checkoutDate,
            String roomId,
            PersonDormitoryTypeInfo personType,
            Set<String> occupantsIds
    ) throws BOSException {
        IOccupants iOccupants = OccupantsFactory.getLocalInstance(ctx);
        FilterInfo filterInfo = new FilterInfo();
        FilterItemCollection filterItems = filterInfo.getFilterItems();
        //
        filterItems.add(new FilterItemInfo("Dormitory", roomId));
        //ססں֮
        filterItems.add(new FilterItemInfo("checkInDate", checkInDate, CompareType.LESS_EQUALS));
        filterItems.add(new FilterItemInfo("checkoutDate", checkInDate, CompareType.GREATER_EQUALS));
        //ססں֮
        filterItems.add(new FilterItemInfo("checkInDate", checkInDate, CompareType.GREATER_EQUALS));
        filterItems.add(new FilterItemInfo("checkInDate", checkoutDate, CompareType.LESS_EQUALS));
        filterInfo.setMaskString("#0 and ((#1 and #2) or (#3 and #4)) ");
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("PersonDormitoryType.id");
        sic.add("PersonDormitoryType.name");
        sic.add("id");
        EntityViewInfo viewInfo = EntityViewInfo.getInstance(filterInfo, sic, null);
        OccupantsCollection occupantsCollection = iOccupants.getOccupantsCollection(viewInfo);
        String personTypeId = personType.getId().toString();
        String personTypeName = personType.getName();
        //ס
        int dormCheckInCount = 0;
        String personDormitoryTypeId = null;
        for (int i = 0; i < occupantsCollection.size(); i++) {
            OccupantsInfo occupantsInfo = occupantsCollection.get(i);
            //Ա
            PersonDormitoryTypeInfo personDormitoryType = occupantsInfo.getPersonDormitoryType();
            personDormitoryTypeId = personDormitoryType.getId().toString();
            String personDormitoryTypeName = personDormitoryType.getName();
            if (!personTypeId.equals(personDormitoryTypeId)) {
                throw new BOSException("Ա[" + personTypeName + "][" + personDormitoryTypeName + "]ס");
            }
            occupantsIds.add(occupantsInfo.getId().toString());
            dormCheckInCount++;
        }
        return dormCheckInCount;
    }

    /**
     * У鷿Ϣ
     *
     * @param ctx
     * @param personInfo
     * @param roomIds    id
     * @return
     * @throws BOSException
     * @throws EASBizException
     */
    protected DormitoryInfo validateDormitoryInfo(
            Context ctx,
            PersonInfo personInfo,
            String roomIds
    ) throws BOSException, EASBizException {
        Genders gender = personInfo.getGender();
        if (gender == null) {
            throw new BOSException("ԱԱΪ!");
        }
        String personInfoName = personInfo.getName();
        IDormitory iDormitory = DormitoryFactory.getLocalInstance(ctx);
        //ѯϢ
        DormitoryInfo dormitoryInfo = iDormitory.getDormitoryInfo(new ObjectUuidPK(roomIds));
        String dormitoryName = dormitoryInfo.getName();
        DormitoryClassification roomClassification = dormitoryInfo.getRoomClassification();
        if (!DormitoryClassification.ROOM.equals(roomClassification)) {
            String classificationAlias = roomClassification.getAlias();
            throw new BOSException("[" + dormitoryName + "]Ϊ" + classificationAlias + "ס!");
        }
        BasicItemStateEnum dormitoryInfoState = dormitoryInfo.getState();
        if (BasicItemStateEnum.DISABLE.equals(dormitoryInfoState)) {
            throw new BOSException("[" + dormitoryName + "]δãס!");
        }
        //
        DormitoryTypeInfo dormitoryType = dormitoryInfo.getDormitoryType();
        Genders roomGender = dormitoryType.getGender();
        if (roomGender != null && gender.getValue() != roomGender.getValue()) {
            String dormitoryTypeName = dormitoryType.getName();
            throw new BOSException("[" + dormitoryName + "]Ϊ" + dormitoryTypeName + "Ա[" + personInfoName + "]Ա𲻷!");
        }
        return dormitoryInfo;
    }
}
